-------------------------------
--File Info--------------------
-------------------------------
--Author: Xander9009
--Created: 17-02-15
--Updated: 22-06-19 (Splinterverse added Spectacle 90090024)

--A list of constants used by the Community Wad. The constants are declared and maintained within the specified file. This is only a reference list.

-------------------------------
--
--Special constants------------
--
-------------------------------

----CW_Strings.LOL
--CW_Language = "English"
--CW_CreatureList

-------------------------------
--                           --
--Multi-Card Constants---------
--                           --
-------------------------------

--These constants will be used on multiple cards.

-------------------------------
--RSN_ObjectDC Registers-------
-------------------------------

----CW_EXILE.LOL
--CW_EXILE_CHEST = 90090001 -- The RSN_ObjectDC register on the Exile Manager. Creates DataChest which contains all Data Chests used by exile functions.

----CW_MORPH.LOL
--CW_MORPH_CHEST = 90090002 -- The RSN_ObjectDC Register for Morph copyable values.

----CW_MANIFEST.LOL
--CW_MANIFEST_CHEST = 90090003 -- The RSN_ObjectDC Register for Manifest copyable values.

----CW_ABILITIES.LOL
--CW_SURGE = 90090004 -- The RSN_ObjectDC Register for checking if a card's Surge cost was paid.
--CW_SPECTACLE = 90090024 -- The RSN_ObjectDC Register for checking if a card's Spectacle cost was paid.

CW_VEHICLE_REGISTER = 90090005 -- The RSN_ObjectDC register containing a vehicle that a creature is piloting.

----CW_COST.LOL
--CW_COST_ENERGY_REGISTER = 90090006 -- RSN_ObjectDC register containing energy producers.
--CW_COST_EXPERIENCE_REGISTER = 90090007 -- RSN_ObjectDC register containing experience producers.

----Custom trigger
CW_TRIGGER = 90090008 -- The RSN_ObjectDC constant which stored which custom trigger was fired.
	--To add a new trigger, ctrl-f for "Custom Trigger values".

CW_RENOWNED = 90090009 -- The RSN_ObjectDC constant for renowned abilities.
CW_MONSTROUS = 90090010 -- The RSN_ObjectDC constant for monstrous abilities.


-------------------------------
--Linked Data Chest Registers--
-------------------------------

----CW_AWAKEN.LOL
--CW_AWAKEN_STATE = 90090001 -- A subchest register of both the CW_AWAKEN_REFCHEST and a card's LinkedDC.


-------------------------------
--Duel Data Chest Registers----
-------------------------------

----CW_EXILE.LOL
--CW_EXILE_CHEST = 90090001 -- DuelDataChest Register for inter-player exile cards.

----CW_MORPH.LOL
--CW_MORPH_CHEST = 90090002 -- The DuelDataChest Register for Morph copyable values.

----CW_MANIFEST.LOL
--CW_MANIFEST_CHEST = 90090003 -- The DuelDataChest Register for Manifest copyable values.

----CW_SHUFFLE.LOL
--CW_SHUFFLE_NO_SEARCH_CHEST = 90090004 -- DuelDataChest Register for data chest containing cards which cause a shuffle without searching the library.

----CW_MANA.LOL
--CW_MANA_AUTOMANA = 90090005 -- DuelDataChest register containing the cards chest and their cost chest.

----Transforming planeswalkers
CW_TRANSFORM_CHEST = 90090006 -- DuelDataChest register containing stored cards for UseCopyableValues.

----VXP_CONSTANTS.LOL
--VXP_VOTE_INFO_CHEST = 100012 -- The Duel Data Chest register where we will put the voting information while voting and for later retrieval.

----MCE_EDH_FUNCTIONS.LOL
--MCE_MY_CHEST = 251 -- Duel Data Chest (and Player Data Chest) register containing various EDH variables.

CW_STARTING_LIFE_TOTAL = 90090007 -- The DuelData Chest register containing the starting life total for the game, if it's been set.

----CW_DC.LOL
--CW_DC_TEMP = 90090008 -- A DuelDataChest register used only within a single RTA for short term storage.

CW_NO_CREATURE_ETB = 90090009 -- A DuelDataChest register used to suppress ETB triggers for creatures.

-------------------------------
--Characteristics--------------
-------------------------------

----CW_ABILITIES_ACTIVE - Reserved
--CW_ABILITIES_ACTIVE = 90090001
--CW_ABILITIES_ACTIVE_CHEST = 90090002

----CW_MORPH.LOL
--CW_CHARACTERISTIC_FACEDOWN = 90090003
--CW_CHARACTERISTIC_MORPH = 90090004
--CW_CHARACTERISTIC_MORPH_TRIGGER = 90090005

----CW_MANIFEST.LOL
--CW_CHARACTERISTIC_FACEDOWN = 90090003
--CW_CHARACTERISTIC_MANIFEST = 90090006
--CW_CHARACTERISTIC_MANIFEST_TRIGGER = 90090007

CW_CHARACTERISTIC_AWAKEN = 90090008

----Phyrexian Mana - for use with Rage Extractor
CW_CHARACTERISTIC_PHYREXIAN_MANA_COST = 90090009

CW_CHARACTERISTIC_HORSEMANSHIP = 90090010

----Can attack as though it didn't have defender
CW_CHARACTERISTIC_DEFENDER_CAN_ATTACK = 90090011

CW_CHARACTERISTIC_DEVOID = 90090012
CW_CHARACTERISTIC_MENACE = 90090013
CW_CHARACTERISTIC_SKULK = 90090014

----Can't Transform
CW_CHARACTERISTIC_CANT_TRANSFORM = 90090015

----Prevents creatures from crewing vehicles
CW_CHARACTERISTIC_CANT_CREW_VEHICLES = 90090016

CW_CHARACTERISTIC_CYCLING = 90090017

CW_CHARACTERISTIC_EMBALM = 90090018
CW_CHARACTERISTIC_ETERNALIZE = 90090019

CW_CHARACTERISTIC_RAMPAGE = 90090020

CW_CHARACTERISTIC_SPLIT_CARD = 90090021

CW_CHARACTERISTIC_TEZZERET_CRUEL_MACHINIST = 90090022
CW_CHARACTERISTIC_TEZZERET_CRUEL_MACHINIST_TRIGGER = 90090023

CW_CHARACTERISTIC_LEGENDARY = 90090024

CW_CHARACTERISTIC_HAS_ADVENTURE = 90090025

-------------------------------
--Player Data Chest Registers--
-------------------------------

----_MANAGER_UPKEEP
CW_UPKEEP_TIME = 90090001 -- Chest register for Upkeep Time Manager.

----CW_TOKENS.LOL
--CW_TOKENS_CHEST = 90090002 -- Chest register in which tokens will be temporarily stored.

----CW_LANGUAGE.LOL
--CW_LANGUAGE = 90090003

----CW_AWAKEN
--CW_AWAKEN_REFCHEST = 90090004 -- Chest register for storing a card's awaken state.

----VXP_CONSTANTS.LOL
--VXP_VOTE_MODIFIER = 100011 -- Player Data Chest register containing each player's vote.

----MCE_EDH_FUNCTIONS.LOL
--MCE_MY_CHEST = 251 -- Player Data Chest (and Duel Data Chest) register containing various EDH variables.

----CW_COMMANDER.LOL
--CW_COMMANDER_DC = 90090005 -- Player Data Chest containing the commander-related variables and pointers.

----CW_TRACKING.LOL
--CW_TRACKING_DISCARD_CHEST = 90090006 -- Player Data Chest register containing all discarded cards.
--CW_TRACKING_TRACKED_CARDS_CHEST = 90090007 -- Player Data Chest register containing all tracked cards.
--CW_TRACKING_CREATURES_CAST_CHEST = 90090008 -- Player Data Chest containing the number of creature spells cast this turn and pointers to each.
--CW_TRACKING_NONCREATURES_CAST_CHEST = 90090009 -- Player Data Chest containing the number of noncreature spells cast this turn and pointers to each.
--CW_TRACKING_ATTACK_CHEST = 90090010 -- Player Data Chest containing all creatures that have attacked, including who controlled them, who they attacked, and on which turn.
--CW_TRACKING_LIFE_GAINED_CHEST = 90090011 -- Player Data Chest containing all instances of life gain.
--CW_TRACKING_COUNTER_CHEST = 90090012 -- Player Data Chest register containing information about counters placed on permanents.



-------------------------------
--TFM_MyPlayerDC Registers-----
-------------------------------

----ARM_FUNCTIONS.LOL
--PLAYER_CLASH_COUNT = 8
--PLAYER_CLASH_RESULT = 9


-------------------------------
--Values-----------------------
-------------------------------

--Custom Trigger values - The CW_TRIGGER register on an object's RSN_ObjectDC is set to one of these to denote the trigger being fired.
CW_TRIGGER_GENERIC = 1
CW_TRIGGER_MANIFEST_START = 2 -- CW_MANIFEST.LOL
CW_TRIGGER_BECAME_RENOWNED = 3
CW_TRIGGER_BECAME_MONSTROUS = 4
CW_TRIGGER_INVESTIGATE = 5
CW_TRIGGER_EMERGE = 6
CW_TRIGGER_CREWED_VEHICLE = 7
CW_TRIGGER_BECAME_MONARCH = 8
CW_TRIGGER_EXERT = 9
CW_TRIGGER_EMBALM = 10
CW_TRIGGER_ETERNALIZE = 11
CW_TRIGGER_EXPLORE = 12
CW_TRIGGER_CITYS_BLESSING = 13
CW_TRIGGER_TEZZERET_CRUEL_MACHINIST = 14
CW_TRIGGER_RESTART_GAME = 15
--ZMB_TRIGGER_SURVEIL = 16
CW_TRIGGER_PLANESWALK = 17


-------------------------------
--                           --
--Single Card Constants      --
--                           --
-------------------------------

--These constants will be used only on one card, but will either affect other cards (granted abilities) or exist in a common chest.


-------------------------------
--RSN_ObjectDC-----------------
-------------------------------

----Pulmonic Sliver
CW_PULMONIC_SLIVER_REGISTER = 900901


-------------------------------
--Duel Data Chest Registers----
-------------------------------

----Enchanted Evening
CW_ENCHANTED_EVENING = 900901

----Urborg, Tomb of Yawgmoth
CW_URBORG_TOMB_OF_YAWGMOTH = 900902

----Blanket of Night
CW_BLANKET_OF_NIGHT = 900903

--Damping Sphere
CW_DAMPING_SPHERE = 900904


-------------------------------
--Player Data Chest Registers--
-------------------------------

----Crucible of the Spirit Dragon
CW_DRAGON_MANA_ACTIVATION = 900901

----Gnarlroot Trapper
CW_ELF_MANA_ACTIVATION = 900902

----The Great Aurora
CW_THE_GREAT_AURORA = 900903

----Ally Encampment
CW_ALLY_MANA_ACTIVATION = 900904

----Archmage Ascension
CW_ARCHMAGE_ASCENSION = 900905

----Eldrazi Temple
CW_ELDRAZI_TEMPLE_MANA_ACTIVATION = 900906

----Curious Homunculus
CW_CURIOUS_HOMUNCULUS_MANA_ACTIVATION = 900907

----Puresteel Paladin
CW_PURESTEEL_PALADIN = 900908

----Approach of the Second Sun
CW_APPROACH_OF_THE_SECOND_SUN = 900909


-------------------------------
--CW_Globals Registers---------
-------------------------------

----CW_GLOBALS.LOL
--CW_Globals_ReservedConstants = {90090001, 90090002} -- CW_Globals won't write to these registers unless they're specified.

----CW_SCREEN.LOL
--CW_SCREEN_REGISTER = 90090001 -- All filter instruction sets are stored in CW_Globals at this register.

----CW_PROTECTION.LOL
--CW_PROTECTION_REGISTER = 90090002 -- CW_Globals register containing protection registration info.

----CW_BLOCKING.LOL
--CW_BLOCKING_REGISTER = 90090003 - CW_Globals register containing blocking registration info.