-------------------------
--File Info--------------
-------------------------
--Author: Xander9009
--Created: 29-11-15
--Updated: 30-11-15

--Functions for working with subtypes, including converting between subtype constants and their respective strings.

-------------------------
--Function List----------
-------------------------

----CW_SubType_GetCreatureTypeString(iCreatureType{, sLanguage})
--Returns a string matching the (iCreatureType} in {sLanguage}.
--(sLanguage) may be a language name or a player (to use his or her chosen language).
--Input: Int{, String/Player}
--Output: String

----CW_SubType_GetCreatureTypeInt(sCreatureType)
--Returns an integer matching the (sCreatureType).
--Input: String
--Output: Int

----CW_SubType_Translate = function(sCreatureType{, sLanguage})
--Attempts to convert {sCreatureType} to its {sLanguage} equivilant.
--(sLanguage) may be a language name or a player (to use his or her chosen language).
--Input: String{, String}
--Output: String

CARD_TYPE_EMBLEM = 11


-------------------------
--Subtype lists----------
-------------------------

ARTIFACT_TYPE_COUNT = 3
ARTIFACT_TYPE_MAX = SIZE_OF_TYPE_BAND * CARD_TYPE_ARTIFACT + ARTIFACT_TYPE_COUNT - 1
InitArtifactType = function()
	ARTIFACT_TYPE_COUNT = ARTIFACT_TYPE_COUNT + 1
	ARTIFACT_TYPE_MAX = SIZE_OF_TYPE_BAND * CARD_TYPE_ARTIFACT + ARTIFACT_TYPE_COUNT - 1
	return ARTIFACT_TYPE_MAX
end

CREATURE_TYPE_COUNT = 221
CREATURE_TYPE_MAX = SIZE_OF_TYPE_BAND * CARD_TYPE_CREATURE + CREATURE_TYPE_COUNT - 1
InitCreatureType = function()
	CREATURE_TYPE_COUNT = CREATURE_TYPE_COUNT + 1
	CREATURE_TYPE_MAX = SIZE_OF_TYPE_BAND * CARD_TYPE_CREATURE + CREATURE_TYPE_COUNT - 1
	return CREATURE_TYPE_MAX
end

ENCHANTMENT_TYPE_COUNT = 3
ENCHANTMENT_TYPE_MAX = SIZE_OF_TYPE_BAND * CARD_TYPE_ENCHANTMENT + ENCHANTMENT_TYPE_COUNT - 1
InitEnchantmentType = function()
	ENCHANTMENT_TYPE_COUNT = ENCHANTMENT_TYPE_COUNT + 1
	ENCHANTMENT_TYPE_MAX = SIZE_OF_TYPE_BAND * CARD_TYPE_ENCHANTMENT + ENCHANTMENT_TYPE_COUNT - 1
	return ENCHANTMENT_TYPE_MAX
end

LAND_TYPE_COUNT = 12
LAND_TYPE_MAX = SIZE_OF_TYPE_BAND * CARD_TYPE_LAND + LAND_TYPE_COUNT - 1
InitLandType = function()
	LAND_TYPE_COUNT = LAND_TYPE_COUNT + 1
	LAND_TYPE_MAX = SIZE_OF_TYPE_BAND * CARD_TYPE_LAND + LAND_TYPE_COUNT - 1
	return LAND_TYPE_MAX
end

CREATURE_TYPE_SURRAKAR = InitCreatureType()
CREATURE_TYPE_GERM = InitCreatureType()
CREATURE_TYPE_HIPPOGRIFF = InitCreatureType()
CREATURE_TYPE_SIREN = InitCreatureType()
CREATURE_TYPE_TOWNSFOLK = InitCreatureType()
CREATURE_TYPE_HYENA = InitCreatureType()
CREATURE_TYPE_NOGGLE = InitCreatureType()
CREATURE_TYPE_GOD = InitCreatureType()
CREATURE_TYPE_NYMPH = InitCreatureType()
CREATURE_TYPE_SABLE = InitCreatureType()
CREATURE_TYPE_LAMIA = InitCreatureType()
CREATURE_TYPE_NAGA = InitCreatureType()
CREATURE_TYPE_PROCESSOR = InitCreatureType()
CREATURE_TYPE_SCION = InitCreatureType()
CREATURE_TYPE_MOLE = InitCreatureType()
CREATURE_TYPE_AETHERBORN = InitCreatureType()
CREATURE_TYPE_PILOT = InitCreatureType()
CREATURE_TYPE_SERVO = InitCreatureType()
CREATURE_TYPE_ASSEMBLYWORKER = InitCreatureType()
CREATURE_TYPE_JACKAL = InitCreatureType()
CREATURE_TYPE_MONKEY = InitCreatureType()
CREATURE_TYPE_CHILD = InitCreatureType()
CREATURE_TYPE_DINOSAUR = InitCreatureType()
CREATURE_TYPE_TRILOBITE = InitCreatureType()
CREATURE_TYPE_AZRA = InitCreatureType()
CREATURE_TYPE_ARMY = InitCreatureType()

ARTIFACT_TYPE_CLUE = InitArtifactType()
ARTIFACT_TYPE_VEHICLE = InitArtifactType()
ARTIFACT_TYPE_TREASURE = InitArtifactType()
ARTIFACT_TYPE_HERO = InitArtifactType()

ENCHANTMENT_TYPE_CARTOUCHE = InitEnchantmentType()
ENCHANTMENT_TYPE_VANGUARD = InitEnchantmentType()
ENCHANTMENT_TYPE_SAGA = InitEnchantmentType()
ENCHANTMENT_TYPE_PLANE = InitEnchantmentType()
ENCHANTMENT_TYPE_PHENOMENON = InitEnchantmentType()

CW_CreatureType = {}
CW_CreatureType.English = {}
CW_CreatureType.English[CREATURE_TYPE_ADVISOR] = "Advisor"
CW_CreatureType.English[CREATURE_TYPE_AETHERBORN] = "Aetherborn"
CW_CreatureType.English[CREATURE_TYPE_ALLY] = "Ally"
CW_CreatureType.English[CREATURE_TYPE_ANEMONE] = "Anemone"
CW_CreatureType.English[CREATURE_TYPE_ANGEL] = "Angel"
CW_CreatureType.English[CREATURE_TYPE_ANTEATER] = "Anteater"
CW_CreatureType.English[CREATURE_TYPE_ANTELOPE] = "Antelope"
CW_CreatureType.English[CREATURE_TYPE_APE] = "Ape"
CW_CreatureType.English[CREATURE_TYPE_ARCHER] = "Archer"
CW_CreatureType.English[CREATURE_TYPE_ARCHON] = "Archon"
CW_CreatureType.English[CREATURE_TYPE_ARTIFICER] = "Artificer"
CW_CreatureType.English[CREATURE_TYPE_ASSASSIN] = "Assassin"
CW_CreatureType.English[CREATURE_TYPE_ASSEMBLY_WORKER] = "Assembly-Worker"
CW_CreatureType.English[CREATURE_TYPE_ASSEMBLYWORKER] = "Assembly-Worker"
CW_CreatureType.English[CREATURE_TYPE_ATOG] = "Atog"
CW_CreatureType.English[CREATURE_TYPE_AUROCHS] = "Aurochs"
CW_CreatureType.English[CREATURE_TYPE_AVATAR] = "Avatar"
CW_CreatureType.English[CREATURE_TYPE_AZRA] = "Azra"
CW_CreatureType.English[CREATURE_TYPE_BADGER] = "Badger"
CW_CreatureType.English[CREATURE_TYPE_BARBARIAN] = "Barbarian"
CW_CreatureType.English[CREATURE_TYPE_BASILISK] = "Basilisk"
CW_CreatureType.English[CREATURE_TYPE_BAT] = "Bat"
CW_CreatureType.English[CREATURE_TYPE_BEAR] = "Bear"
CW_CreatureType.English[CREATURE_TYPE_BEAST] = "Beast"
CW_CreatureType.English[CREATURE_TYPE_BEEBLE] = "Beeble"
CW_CreatureType.English[CREATURE_TYPE_BERSERKER] = "Berserker"
CW_CreatureType.English[CREATURE_TYPE_BIRD] = "Bird"
CW_CreatureType.English[CREATURE_TYPE_BLINKMOTH] = "Blinkmoth"
CW_CreatureType.English[CREATURE_TYPE_BOAR] = "Boar"
CW_CreatureType.English[CREATURE_TYPE_BRINGER] = "Bringer"
CW_CreatureType.English[CREATURE_TYPE_BRUSHWAGG] = "Brushwagg"
CW_CreatureType.English[CREATURE_TYPE_CAMARID] = "Camarid"
CW_CreatureType.English[CREATURE_TYPE_CAMEL] = "Camel"
CW_CreatureType.English[CREATURE_TYPE_CARIBOU] = "Caribou"
CW_CreatureType.English[CREATURE_TYPE_CARRIER] = "Carrier"
CW_CreatureType.English[CREATURE_TYPE_CAT] = "Cat"
CW_CreatureType.English[CREATURE_TYPE_CENTAUR] = "Centaur"
CW_CreatureType.English[CREATURE_TYPE_CEPHALID] = "Cephalid"
CW_CreatureType.English[CREATURE_TYPE_CHILD] = "Child"
CW_CreatureType.English[CREATURE_TYPE_CHIMERA] = "Chimera"
CW_CreatureType.English[CREATURE_TYPE_CITIZEN] = "Citizen"
CW_CreatureType.English[CREATURE_TYPE_CLERIC] = "Cleric"
CW_CreatureType.English[CREATURE_TYPE_COCKATRICE] = "Cockatrice"
CW_CreatureType.English[CREATURE_TYPE_CONSTRUCT] = "Construct"
CW_CreatureType.English[CREATURE_TYPE_COWARD] = "Coward"
CW_CreatureType.English[CREATURE_TYPE_CRAB] = "Crab"
CW_CreatureType.English[CREATURE_TYPE_CROCODILE] = "Crocodile"
CW_CreatureType.English[CREATURE_TYPE_CYCLOPS] = "Cyclops"
CW_CreatureType.English[CREATURE_TYPE_DAUTHI] = "Dauthi"
CW_CreatureType.English[CREATURE_TYPE_DEMON] = "Demon"
CW_CreatureType.English[CREATURE_TYPE_DESERTER] = "Deserter"
CW_CreatureType.English[CREATURE_TYPE_DEVIL] = "Devil"
CW_CreatureType.English[CREATURE_TYPE_DINOSAUR] = "Dinosaur"
CW_CreatureType.English[CREATURE_TYPE_DJINN] = "Djinn"
CW_CreatureType.English[CREATURE_TYPE_DRAGON] = "Dragon"
CW_CreatureType.English[CREATURE_TYPE_DRAKE] = "Drake"
CW_CreatureType.English[CREATURE_TYPE_DREADNOUGHT] = "Dreadnought"
CW_CreatureType.English[CREATURE_TYPE_DRONE] = "Drone"
CW_CreatureType.English[CREATURE_TYPE_DRUID] = "Druid"
CW_CreatureType.English[CREATURE_TYPE_DRYAD] = "Dryad"
CW_CreatureType.English[CREATURE_TYPE_DWARF] = "Dwarf"
CW_CreatureType.English[CREATURE_TYPE_EFREET] = "Efreet"
CW_CreatureType.English[CREATURE_TYPE_EGG] = "Egg"
CW_CreatureType.English[CREATURE_TYPE_ELDER] = "Elder"
CW_CreatureType.English[CREATURE_TYPE_ELDRAZI] = "Eldrazi"
CW_CreatureType.English[CREATURE_TYPE_ELEMENTAL] = "Elemental"
CW_CreatureType.English[CREATURE_TYPE_ELEPHANT] = "Elephant"
CW_CreatureType.English[CREATURE_TYPE_ELF] = "Elf"
CW_CreatureType.English[CREATURE_TYPE_ELK] = "Elk"
CW_CreatureType.English[CREATURE_TYPE_EYE] = "Eye"
CW_CreatureType.English[CREATURE_TYPE_FAERIE] = "Faerie"
CW_CreatureType.English[CREATURE_TYPE_FERRET] = "Ferret"
CW_CreatureType.English[CREATURE_TYPE_FISH] = "Fish"
CW_CreatureType.English[CREATURE_TYPE_FLAGBEARER] = "Flagbearer"
CW_CreatureType.English[CREATURE_TYPE_FOX] = "Fox"
CW_CreatureType.English[CREATURE_TYPE_FROG] = "Frog"
CW_CreatureType.English[CREATURE_TYPE_FUNGUS] = "Fungus"
CW_CreatureType.English[CREATURE_TYPE_GARGOYLE] = "Gargoyle"
CW_CreatureType.English[CREATURE_TYPE_GERM] = "Germ"
CW_CreatureType.English[CREATURE_TYPE_GIANT] = "Giant"
CW_CreatureType.English[CREATURE_TYPE_GNOME] = "Gnome"
CW_CreatureType.English[CREATURE_TYPE_GOAT] = "Goat"
CW_CreatureType.English[CREATURE_TYPE_GOBLIN] = "Goblin"
CW_CreatureType.English[CREATURE_TYPE_GOD] = "God"
CW_CreatureType.English[CREATURE_TYPE_GOLEM] = "Golem"
CW_CreatureType.English[CREATURE_TYPE_GORGON] = "Gorgon"
CW_CreatureType.English[CREATURE_TYPE_GRAVEBORN] = "Graveborn"
CW_CreatureType.English[CREATURE_TYPE_GREMLIN] = "Gremlin"
CW_CreatureType.English[CREATURE_TYPE_GRIFFIN] = "Griffin"
CW_CreatureType.English[CREATURE_TYPE_HAG] = "Hag"
CW_CreatureType.English[CREATURE_TYPE_HARPY] = "Harpy"
CW_CreatureType.English[CREATURE_TYPE_HELLION] = "Hellion"
CW_CreatureType.English[CREATURE_TYPE_HIPPOGRIFF] = "Hippogriff"
CW_CreatureType.English[CREATURE_TYPE_HIPPO] = "Hippo"
CW_CreatureType.English[CREATURE_TYPE_HOMARID] = "Homarid"
CW_CreatureType.English[CREATURE_TYPE_HOMUNCULUS] = "Homunculus"
CW_CreatureType.English[CREATURE_TYPE_HORROR] = "Horror"
CW_CreatureType.English[CREATURE_TYPE_HORSE] = "Horse"
CW_CreatureType.English[CREATURE_TYPE_HOUND] = "Hound"
CW_CreatureType.English[CREATURE_TYPE_HUMAN] = "Human"
CW_CreatureType.English[CREATURE_TYPE_HYDRA] = "Hydra"
CW_CreatureType.English[CREATURE_TYPE_HYENA] = "Hyena"
CW_CreatureType.English[CREATURE_TYPE_ILLUSION] = "Illusion"
CW_CreatureType.English[CREATURE_TYPE_IMP] = "Imp"
CW_CreatureType.English[CREATURE_TYPE_INCARNATION] = "Incarnation"
CW_CreatureType.English[CREATURE_TYPE_INSECT] = "Insect"
CW_CreatureType.English[CREATURE_TYPE_JACKAL] = "Jackal"
CW_CreatureType.English[CREATURE_TYPE_JELLYFISH] = "Jellyfish"
CW_CreatureType.English[CREATURE_TYPE_JUGGERNAUT] = "Juggernaut"
CW_CreatureType.English[CREATURE_TYPE_KAVU] = "Kavu"
CW_CreatureType.English[CREATURE_TYPE_KIRIN] = "Kirin"
CW_CreatureType.English[CREATURE_TYPE_KITHKIN] = "Kithkin"
CW_CreatureType.English[CREATURE_TYPE_KNIGHT] = "Knight"
CW_CreatureType.English[CREATURE_TYPE_KOBOLD] = "Kobold"
CW_CreatureType.English[CREATURE_TYPE_KOR] = "Kor"
CW_CreatureType.English[CREATURE_TYPE_KRAKEN] = "Kraken"
CW_CreatureType.English[CREATURE_TYPE_LAMIA] = "Lamia"
CW_CreatureType.English[CREATURE_TYPE_LAMMASU] = "Lammasu"
CW_CreatureType.English[CREATURE_TYPE_LEECH] = "Leech"
CW_CreatureType.English[CREATURE_TYPE_LEVIATHAN] = "Leviathan"
CW_CreatureType.English[CREATURE_TYPE_LHURGOYF] = "Lhurgoyf"
CW_CreatureType.English[CREATURE_TYPE_LICID] = "Licid"
CW_CreatureType.English[CREATURE_TYPE_LIZARD] = "Lizard"
CW_CreatureType.English[CREATURE_TYPE_MANTICORE] = "Manticore"
CW_CreatureType.English[CREATURE_TYPE_MASTICORE] = "Masticore"
CW_CreatureType.English[CREATURE_TYPE_MERCENARY] = "Mercenary"
CW_CreatureType.English[CREATURE_TYPE_MERFOLK] = "Merfolk"
CW_CreatureType.English[CREATURE_TYPE_METATHRAN] = "Metathran"
CW_CreatureType.English[CREATURE_TYPE_MINION] = "Minion"
CW_CreatureType.English[CREATURE_TYPE_MINOTAUR] = "Minotaur"
CW_CreatureType.English[CREATURE_TYPE_MOLE] = "Mole"
CW_CreatureType.English[CREATURE_TYPE_MONGER] = "Monger"
CW_CreatureType.English[CREATURE_TYPE_MONGOOSE] = "Mongoose"
CW_CreatureType.English[CREATURE_TYPE_MONKEY] = "Monkey"
CW_CreatureType.English[CREATURE_TYPE_MONK] = "Monk"
CW_CreatureType.English[CREATURE_TYPE_MOONFOLK] = "Moonfolk"
CW_CreatureType.English[CREATURE_TYPE_MUTANT] = "Mutant"
CW_CreatureType.English[CREATURE_TYPE_MYR] = "Myr"
CW_CreatureType.English[CREATURE_TYPE_MYSTIC] = "Mystic"
CW_CreatureType.English[CREATURE_TYPE_NAGA] = "Naga"
CW_CreatureType.English[CREATURE_TYPE_NAUTILUS] = "Nautilus"
CW_CreatureType.English[CREATURE_TYPE_NEPHILIM] = "Nephilim"
CW_CreatureType.English[CREATURE_TYPE_NIGHTMARE] = "Nightmare"
CW_CreatureType.English[CREATURE_TYPE_NIGHTSTALKER] = "Nightstalker"
CW_CreatureType.English[CREATURE_TYPE_NINJA] = "Ninja"
CW_CreatureType.English[CREATURE_TYPE_NOGGLE] = "Noggle"
CW_CreatureType.English[CREATURE_TYPE_NOMAD] = "Nomad"
CW_CreatureType.English[CREATURE_TYPE_NYMPH] = "Nymph"
CW_CreatureType.English[CREATURE_TYPE_OCTOPUS] = "Octopus"
CW_CreatureType.English[CREATURE_TYPE_OGRE] = "Ogre"
CW_CreatureType.English[CREATURE_TYPE_OOZE] = "Ooze"
CW_CreatureType.English[CREATURE_TYPE_ORB] = "Orb"
CW_CreatureType.English[CREATURE_TYPE_ORC] = "Orc"
CW_CreatureType.English[CREATURE_TYPE_ORGG] = "Orgg"
CW_CreatureType.English[CREATURE_TYPE_OUPHE] = "Ouphe"
CW_CreatureType.English[CREATURE_TYPE_OX] = "Ox"
CW_CreatureType.English[CREATURE_TYPE_OYSTER] = "Oyster"
CW_CreatureType.English[CREATURE_TYPE_PEGASUS] = "Pegasus"
CW_CreatureType.English[CREATURE_TYPE_PENTAVITE] = "Pentavite"
CW_CreatureType.English[CREATURE_TYPE_PEST] = "Pest"
CW_CreatureType.English[CREATURE_TYPE_PHELDDAGRIF] = "Phelddagrif"
CW_CreatureType.English[CREATURE_TYPE_PHOENIX] = "Phoenix"
CW_CreatureType.English[CREATURE_TYPE_PILOT] = "Pilot"
CW_CreatureType.English[CREATURE_TYPE_PINCHER] = "Pincher"
CW_CreatureType.English[CREATURE_TYPE_PIRATE] = "Pirate"
CW_CreatureType.English[CREATURE_TYPE_PLANT] = "Plant"
CW_CreatureType.English[CREATURE_TYPE_PRAETOR] = "Praetor"
CW_CreatureType.English[CREATURE_TYPE_PRISM] = "Prism"
CW_CreatureType.English[CREATURE_TYPE_PROCESSOR] = "Processor"
CW_CreatureType.English[CREATURE_TYPE_RABBIT] = "Rabbit"
CW_CreatureType.English[CREATURE_TYPE_RAT] = "Rat"
CW_CreatureType.English[CREATURE_TYPE_REBEL] = "Rebel"
CW_CreatureType.English[CREATURE_TYPE_REFLECTION] = "Reflection"
CW_CreatureType.English[CREATURE_TYPE_RHINO] = "Rhino"
CW_CreatureType.English[CREATURE_TYPE_RIGGER] = "Rigger"
CW_CreatureType.English[CREATURE_TYPE_ROGUE] = "Rogue"
CW_CreatureType.English[CREATURE_TYPE_SABLE] = "Sable"
CW_CreatureType.English[CREATURE_TYPE_SALAMANDER] = "Salamander"
CW_CreatureType.English[CREATURE_TYPE_SAMURAI] = "Samurai"
CW_CreatureType.English[CREATURE_TYPE_SAND] = "Sand"
CW_CreatureType.English[CREATURE_TYPE_SAPROLING] = "Saproling"
CW_CreatureType.English[CREATURE_TYPE_SATYR] = "Satyr"
CW_CreatureType.English[CREATURE_TYPE_SCARECROW] = "Scarecrow"
CW_CreatureType.English[CREATURE_TYPE_SCION] = "Scion"
CW_CreatureType.English[CREATURE_TYPE_SCORPION] = "Scorpion"
CW_CreatureType.English[CREATURE_TYPE_SCOUT] = "Scout"
CW_CreatureType.English[CREATURE_TYPE_SERF] = "Serf"
CW_CreatureType.English[CREATURE_TYPE_SERPENT] = "Serpent"
CW_CreatureType.English[CREATURE_TYPE_SERVO] = "Servo"
CW_CreatureType.English[CREATURE_TYPE_SHADE] = "Shade"
CW_CreatureType.English[CREATURE_TYPE_SHAMAN] = "Shaman"
CW_CreatureType.English[CREATURE_TYPE_SHAPESHIFTER] = "Shapeshifter"
CW_CreatureType.English[CREATURE_TYPE_SHEEP] = "Sheep"
CW_CreatureType.English[CREATURE_TYPE_SIREN] = "Siren"
CW_CreatureType.English[CREATURE_TYPE_SKELETON] = "Skeleton"
CW_CreatureType.English[CREATURE_TYPE_SLITH] = "Slith"
CW_CreatureType.English[CREATURE_TYPE_SLIVER] = "Sliver"
CW_CreatureType.English[CREATURE_TYPE_SLUG] = "Slug"
CW_CreatureType.English[CREATURE_TYPE_SNAKE] = "Snake"
CW_CreatureType.English[CREATURE_TYPE_SOLDIER] = "Soldier"
CW_CreatureType.English[CREATURE_TYPE_SOLTARI] = "Soltari"
CW_CreatureType.English[CREATURE_TYPE_SPAWN] = "Spawn"
CW_CreatureType.English[CREATURE_TYPE_SPECTER] = "Specter"
CW_CreatureType.English[CREATURE_TYPE_SPELLSHAPER] = "Spellshaper"
CW_CreatureType.English[CREATURE_TYPE_SPHINX] = "Sphinx"
CW_CreatureType.English[CREATURE_TYPE_SPIDER] = "Spider"
CW_CreatureType.English[CREATURE_TYPE_SPIKE] = "Spike"
CW_CreatureType.English[CREATURE_TYPE_SPIRIT] = "Spirit"
CW_CreatureType.English[CREATURE_TYPE_SPLINTER] = "Splinter"
CW_CreatureType.English[CREATURE_TYPE_SPONGE] = "Sponge"
CW_CreatureType.English[CREATURE_TYPE_SQUID] = "Squid"
CW_CreatureType.English[CREATURE_TYPE_SQUIRREL] = "Squirrel"
CW_CreatureType.English[CREATURE_TYPE_STARFISH] = "Starfish"
CW_CreatureType.English[CREATURE_TYPE_SURRAKAR] = "Surrakar"
CW_CreatureType.English[CREATURE_TYPE_SURVIVOR] = "Survivor"
CW_CreatureType.English[CREATURE_TYPE_TETRAVITE] = "Tetravite"
CW_CreatureType.English[CREATURE_TYPE_THALAKOS] = "Thalakos"
CW_CreatureType.English[CREATURE_TYPE_THOPTER] = "Thopter"
CW_CreatureType.English[CREATURE_TYPE_THRULL] = "Thrull"
CW_CreatureType.English[CREATURE_TYPE_TOWNSFOLK] = "Townsfolk"
CW_CreatureType.English[CREATURE_TYPE_TRAP] = "Trap"
CW_CreatureType.English[CREATURE_TYPE_TREEFOLK] = "Treefolk"
CW_CreatureType.English[CREATURE_TYPE_TRILOBITE] = "Trilobite"
CW_CreatureType.English[CREATURE_TYPE_TRISKELAVITE] = "Triskelavite"
CW_CreatureType.English[CREATURE_TYPE_TROLL] = "Troll"
CW_CreatureType.English[CREATURE_TYPE_TURTLE] = "Turtle"
CW_CreatureType.English[CREATURE_TYPE_UNICORN] = "Unicorn"
CW_CreatureType.English[CREATURE_TYPE_VAMPIRE] = "Vampire"
CW_CreatureType.English[CREATURE_TYPE_VEDALKEN] = "Vedalken"
CW_CreatureType.English[CREATURE_TYPE_VIASHINO] = "Viashino"
CW_CreatureType.English[CREATURE_TYPE_VOLVER] = "Volver"
CW_CreatureType.English[CREATURE_TYPE_WALL] = "Wall"
CW_CreatureType.English[CREATURE_TYPE_WARRIOR] = "Warrior"
CW_CreatureType.English[CREATURE_TYPE_WEIRD] = "Weird"
CW_CreatureType.English[CREATURE_TYPE_WEREWOLF] = "Werewolf"
CW_CreatureType.English[CREATURE_TYPE_WHALE] = "Whale"
CW_CreatureType.English[CREATURE_TYPE_WIZARD] = "Wizard"
CW_CreatureType.English[CREATURE_TYPE_WOLF] = "Wolf"
CW_CreatureType.English[CREATURE_TYPE_WOLVERINE] = "Wolverine"
CW_CreatureType.English[CREATURE_TYPE_WOMBAT] = "Wombat"
CW_CreatureType.English[CREATURE_TYPE_WORM] = "Worm"
CW_CreatureType.English[CREATURE_TYPE_WRAITH] = "Wraith"
CW_CreatureType.English[CREATURE_TYPE_WURM] = "Wurm"
CW_CreatureType.English[CREATURE_TYPE_YETI] = "Yeti"
CW_CreatureType.English[CREATURE_TYPE_ZOMBIE] = "Zombie"
CW_CreatureType.English[CREATURE_TYPE_ZUBERA] = "Zubera"
CW_CreatureType.French = {}
CW_CreatureType.Spanish = {}
CW_CreatureType.German = {}
CW_CreatureType.Italian = {}
CW_CreatureType.Japanese = {}
CW_CreatureType.Korean = {}
CW_CreatureType.Russian = {}
CW_CreatureType.Portuguese = {}
CW_CreatureType.ChineseSimplified = {}
CW_CreatureType.ChineseTraditional = {}

CW_CreatureType.Advisor = CREATURE_TYPE_ADVISOR

-------------------------
--Functions Definitions--
-------------------------

--Returns a string matching the (iCreatureType} in {sLanguage}.
--(sLanguage) may be a language name or a player (to use his or her chosen language).
--Input: Int{, String/Player}
--Output: String
CW_SubType_GetCreatureTypeString = function(iCreatureType, sLanguage)
	if iCreatureType == nil or type(iCreatureType) ~= "number" or sLanguage == 0 then
		return ""
	end
	if sLanguage ~= nil and type(sLanguage) ~= "string" then
		local iCount = MTG():GetNumberOfPlayers()
		for i=0,iCount-1 do
			local oPlayer = MTG():GetNthPlayer(i)
			if sLanguage == oPlayer then
				sLanguage = CW_Language_GetString(oPlayer)
				break
			end
		end
	end
	if sLanguage == nil or type(sLanguage) ~= "string" or sLanguage == "" then
		sLanguage = CW_Language_GetString()
	end
	local sType = CW_CreatureType[sLanguage][iCreatureType]
	if sType ~= nil and sType ~= "" then
		return sType
	end
	return CW_CreatureType.English[iCreatureType]
end

--Returns an integer matching the (sCreatureType).
--Input: String
--Output: Int
CW_SubType_GetCreatureTypeInt = function(sCreatureType)
	if sCreatureType == nil or type(sCreatureType) ~= "string" then
		return 0
	end
	local iType = CW_CreatureType[sCreatureType]
	if iType ~= nil then
		return iType
	end
	return 0
end

--Attempts to convert {sCreatureType} to its {sLanguage} equivalent.
--(sLanguage) may be a language name or a player (to use his or her chosen language).
--Input: String{, String/Player}
--Output: String
CW_SubType_Translate = function(sCreatureType, sLanguage)
	if sCreatureType == nil or type(sCreatureType) ~= "string" then
		return ""
	end
	if sLanguage ~= nil and type(sLanguage) ~= "string" then
		local iCount = MTG():GetNumberOfPlayers()
		for i=0,iCount-1 do
			local oPlayer = MTG():GetNthPlayer(i)
			if sLanguage == oPlayer then
				sLanguage = CW_Language_GetString(oPlayer)
				break
			end
		end
	end
	if sLanguage == nil or type(sLanguage) ~= "string" or sLanguage == "" then
		sLanguage = CW_Language_GetString()
	end
	local sTranslatedCreatureType = CW_CreatureType[sLanguage][CW_CreatureType_GetCreatureTypeInt(sCreatureType)]
	if sTranslatedCreatureType ~= nil and sTranslatedCreatureType ~= "" then
		return sTranslatedCreatureType
	end
	return sCreatureType
end